#!/bin/sh
( cd usr/bin ; rm -rf faillog )
( cd usr/bin ; ln -sf ../sbin/faillog faillog )
( cd usr/bin ; rm -rf lastlog )
( cd usr/bin ; ln -sf ../sbin/lastlog lastlog )
( cd usr/bin ; rm -rf sg )
( cd usr/bin ; ln -sf newgrp sg )
( cd usr/sbin ; rm -rf vigr )
( cd usr/sbin ; ln -sf vipw vigr )
( cd bin ; rm -rf sulogin )
( cd bin ; ln -sf ../sbin/sulogin sulogin )

config() {
 NEW="$1"
 OLD="`dirname $NEW`/`basename $NEW .new`"
 if [ ! -r $OLD ] ; then
  mv $NEW $OLD
  echo ""
  echo "  --> Installed new configuration file $OLD"
 elif [ "`cat $OLD 2> /dev/null | md5sum`" = "`cat $NEW 2> /dev/null | md5sum`" ] ; then
  rm -f $NEW
 else
  echo ""
  echo "  --> Installed new configuration file: $NEW"
  echo "  --> Setting ownership and permissions to match $OLD"
  cp -a $OLD $NEW.incoming
  cat $NEW > $NEW.incoming
  mv $NEW.incoming $NEW
  echo "  --> Preserving your old configuration file: $OLD"
  echo "  Please examine your existing configuration file: $OLD"
  echo "  to see if it needs to be updated from: $NEW"
  echo ""
 fi
}

config etc/default/useradd.new
config etc/login.access.new
config etc/login.defs.new
config var/log/faillog.new

rm -f var/log/faillog.new

chmod 4711 bin/su
chmod 4711 usr/bin/chage
chmod 4711 usr/bin/chfn
chmod 4711 usr/bin/chsh
chmod 4711 usr/bin/expiry
chmod 4711 usr/bin/gpasswd
chmod 4711 usr/bin/newgrp
chmod 4711 usr/bin/passwd
chmod 4711 usr/sbin/faillog
chmod 4711 usr/sbin/lastlog


